Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/ABL/ablrst.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/ABL/ablrst.F90	(revision 12928)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/ABL/ablrst.F90	(revision 12928)
@@ -0,0 +1,182 @@
+MODULE ablrst
+   !!======================================================================
+   !!                     ***  MODULE  ablrst  ***
+   !!       abl :  write/read the abl restart file
+   !!======================================================================
+   !! History:   4.0  !  2018     (some people)                         ABL
+   !!----------------------------------------------------------------------
+   !!   abl_rst_opn   : open  restart file
+   !!   abl_rst_write : write restart file 
+   !!   abl_rst_read  : read  restart file 
+   !!----------------------------------------------------------------------
+   USE abl            ! abl variables
+   USE par_abl        ! abl parameters
+   USE dom_oce        ! ocean domain
+   USE sbc_oce , ONLY : nn_fsbc, jpka
+   !
+   USE in_out_manager ! I/O manager
+   USE iom            ! I/O manager library
+   USE lib_mpp        ! MPP library
+   USE lib_fortran    ! fortran utilities (glob_sum + no signed zero)
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   abl_rst_opn     ! called by ablstp
+   PUBLIC   abl_rst_write   ! called by ablstp
+   PUBLIC   abl_rst_read    ! called by abl_init
+
+   !!----------------------------------------------------------------------
+   !! NEMO/ABL 4.0 , NEMO Consortium (2018)
+   !! $Id: ablrst.F90 11413 2019-08-06 15:59:22Z gsamson $
+   !! Software governed by the CeCILL license (see ./LICENSE)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE abl_rst_opn( kt )
+      !!----------------------------------------------------------------------
+      !!                    ***  abl_rst_opn  ***
+      !!
+      !! ** purpose  :   open restart file
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt       ! number of iteration
+      !
+      CHARACTER(len=20)   ::   clkt     ! ocean time-step define as a character
+      CHARACTER(len=50)   ::   clname   ! abl output restart file name
+      CHARACTER(len=256)  ::   clpath   ! full path to abl output restart file 
+      !!----------------------------------------------------------------------
+      !
+      IF( kt == nit000 )   lrst_abl = .FALSE.   ! default definition
+
+      IF( ln_rst_list .OR. nn_stock /= -1 ) THEN
+      ! in order to get better performances with NetCDF format, we open and define the abl restart file 
+      ! one abl time step before writing the data (-> at nitrst - 2*nn_fsbc + 1), except if we write abl 
+      ! restart files every abl time step or if an abl restart file was writen at nitend - 2*nn_fsbc + 1
+      IF( kt == nitrst - 2*nn_fsbc + 1 .OR. nn_stock == nn_fsbc    &
+         &                             .OR. ( kt == nitend - nn_fsbc + 1 .AND. .NOT. lrst_abl ) ) THEN
+         IF( nitrst <= nitend .AND. nitrst > 0 ) THEN
+            ! beware of the format used to write kt (default is i8.8, that should be large enough...)
+            IF( nitrst > 99999999 ) THEN   ;   WRITE(clkt, *       ) nitrst
+            ELSE                           ;   WRITE(clkt, '(i8.8)') nitrst
+            ENDIF
+            ! create the file
+            clname = TRIM(cexper)//"_"//TRIM(ADJUSTL(clkt))//"_"//TRIM(cn_ablrst_out)
+            clpath = TRIM(cn_ablrst_outdir) 
+            IF( clpath(LEN_TRIM(clpath):) /= '/' ) clpath = TRIM(clpath)//'/'
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) '             open abl restart NetCDF file: ',TRIM(clpath)//clname
+               IF( kt == nitrst - 2*nn_fsbc + 1 ) THEN
+                  WRITE(numout,*) '             kt = nitrst - 2*nn_fsbc + 1 = ', kt,' date= ', ndastp
+               ELSE
+                  WRITE(numout,*) '             kt = '                         , kt,' date= ', ndastp
+               ENDIF
+            ENDIF
+            !
+            CALL iom_open( TRIM(clpath)//TRIM(clname), numraw, ldwrt = .TRUE., kdlev = jpka, cdcomp = 'ABL' )
+            lrst_abl = .TRUE.
+         ENDIF
+      ENDIF
+      ENDIF
+      !
+   END SUBROUTINE abl_rst_opn
+
+
+   SUBROUTINE abl_rst_write( kt )
+      !!----------------------------------------------------------------------
+      !!                    ***  abl_rst_write  ***
+      !!
+      !! ** purpose  :   write restart file
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt     ! number of iteration
+      !!
+      INTEGER ::   iter
+      !!----------------------------------------------------------------------
+
+      iter = kt + nn_fsbc - 1   ! abl restarts are written at kt == nitrst - nn_fsbc + 1
+
+      IF( iter == nitrst ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'abl_rst_write : write abl restart file  kt =', kt
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~'         
+      ENDIF
+
+      ! Write in numraw (if iter == nitrst)
+      ! ------------------ 
+      !                                                                        ! calendar control
+      CALL iom_rstput( iter, nitrst, numraw, 'nn_fsbc', REAL( nn_fsbc, wp ) )      ! time-step 
+      CALL iom_rstput( iter, nitrst, numraw, 'kt_abl' , REAL( iter   , wp ) )      ! date
+      CALL iom_delay_rst( 'WRITE', 'ABL', numraw )   ! save only abl delayed global communication variables
+
+      ! Prognostic variables
+      CALL iom_rstput( iter, nitrst, numraw,   'u_abl',   u_abl(:,:,:,nt_n      ) )
+      CALL iom_rstput( iter, nitrst, numraw,   'v_abl',   v_abl(:,:,:,nt_n      ) )
+      CALL iom_rstput( iter, nitrst, numraw,   't_abl',  tq_abl(:,:,:,nt_n,jp_ta) )
+      CALL iom_rstput( iter, nitrst, numraw,   'q_abl',  tq_abl(:,:,:,nt_n,jp_qa) )
+      CALL iom_rstput( iter, nitrst, numraw, 'tke_abl', tke_abl(:,:,:,nt_n      ) )
+      CALL iom_rstput( iter, nitrst, numraw, 'avm_abl', avm_abl(:,:,:           ) )
+      CALL iom_rstput( iter, nitrst, numraw, 'avt_abl', avt_abl(:,:,:           ) )
+      CALL iom_rstput( iter, nitrst, numraw, 'mxl_abl', mxl_abl(:,:,:           ) )
+      CALL iom_rstput( iter, nitrst, numraw,    'pblh',    pblh(:,:             ) )
+      !
+
+      ! close restart file
+      ! ------------------
+      IF( iter == nitrst ) THEN
+         CALL iom_close( numraw )
+         lrst_abl = .FALSE.
+      ENDIF
+      !
+   END SUBROUTINE abl_rst_write
+
+
+   SUBROUTINE abl_rst_read
+      !!----------------------------------------------------------------------
+      !!                    ***  abl_rst_read  ***
+      !!
+      !! ** purpose  :   read restart file
+      !!----------------------------------------------------------------------
+      REAL(wp)          ::   zfabl, ziter
+      !!----------------------------------------------------------------------
+
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'abl_rst_read: read abl NetCDF restart file'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+      ENDIF
+
+      CALL iom_open ( TRIM(cn_ablrst_indir)//'/'//cn_ablrst_in, numrar )
+
+      ! Time info
+      CALL iom_get( numrar, 'nn_fsbc', zfabl )
+      CALL iom_get( numrar, 'kt_abl' , ziter )    
+      IF(lwp) WRITE(numout,*) '   read abl restart file at time step    : ', ziter
+      IF(lwp) WRITE(numout,*) '   in any case we force it to nit000 - 1 : ', nit000 - 1
+
+      ! Control of date
+      IF( ( nit000 - NINT(ziter) ) /= 1 .AND. ABS( nrstdt ) == 1 )   &
+         &     CALL ctl_stop( 'abl_rst_read ===>>>> : problem with nit000 in abl restart',  &
+         &                   '   verify the file or rerun with the value 0 for the',        &
+         &                   '   control of time parameter  nrstdt' )
+      IF( NINT(zfabl) /= nn_fsbc          .AND. ABS( nrstdt ) == 1 )   &
+         &     CALL ctl_stop( 'abl_rst_read ===>>>> : problem with nn_fsbc in abl restart',  &
+         &                   '   verify the file or rerun with the value 0 for the',         &
+         &                   '   control of time parameter  nrstdt' )
+
+      ! --- mandatory fields --- ! 
+      CALL iom_get( numrar, jpdom_autoglo,   'u_abl',   u_abl(:,:,:,nt_n      ) )
+      CALL iom_get( numrar, jpdom_autoglo,   'v_abl',   v_abl(:,:,:,nt_n      ) )
+      CALL iom_get( numrar, jpdom_autoglo,   't_abl',  tq_abl(:,:,:,nt_n,jp_ta) )
+      CALL iom_get( numrar, jpdom_autoglo,   'q_abl',  tq_abl(:,:,:,nt_n,jp_qa) )
+      CALL iom_get( numrar, jpdom_autoglo, 'tke_abl', tke_abl(:,:,:,nt_n      ) )
+      CALL iom_get( numrar, jpdom_autoglo, 'avm_abl', avm_abl(:,:,:           ) )
+      CALL iom_get( numrar, jpdom_autoglo, 'avt_abl', avt_abl(:,:,:           ) )
+      CALL iom_get( numrar, jpdom_autoglo, 'mxl_abl', mxl_abl(:,:,:           ) )
+      CALL iom_get( numrar, jpdom_autoglo,    'pblh',    pblh(:,:             ) )
+      CALL iom_delay_rst( 'READ', 'ABL', numrar )   ! read only abl delayed global communication variables
+
+   END SUBROUTINE abl_rst_read
+
+
+   !!======================================================================
+END MODULE ablrst
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/ABL/par_abl.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/ABL/par_abl.F90	(revision 12928)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/ABL/par_abl.F90	(revision 12928)
@@ -0,0 +1,100 @@
+MODULE par_abl
+   !!======================================================================
+   !!                        ***  par_abl  ***
+   !! ABL :   set the Atmospheric Boundary Layer parameters
+   !!======================================================================
+   !! History :  4.0  !  2019-03  (F. Lemarié & G. Samson)  Original code
+   !!----------------------------------------------------------------------
+   USE par_kind          ! kind parameters
+   USE par_oce           ! to access horizontal domain size & mpp decomposition
+
+   IMPLICIT NONE
+   PUBLIC
+
+   !!---------------------------------------------------------------------
+   !! Active tracer parameters
+   !!---------------------------------------------------------------------
+   INTEGER , PUBLIC, PARAMETER ::   jptq   = 2     !: Number of active tracers (=2, i.e. T & q )
+   INTEGER , PUBLIC, PARAMETER ::   jp_ta  = 1     !: indice for temperature
+   INTEGER , PUBLIC, PARAMETER ::   jp_qa  = 2     !: indice for humidity
+   INTEGER , PUBLIC, PARAMETER ::   jptime = 2     !: number of time indices stored in memory
+
+   !!---------------------------------------------------------------------
+   !! namABL Namelist options  
+   !!---------------------------------------------------------------------   
+   INTEGER , PUBLIC            ::   nn_amxl        !: mixing length option 
+   INTEGER , PUBLIC            ::   nn_dyn_restore !: restoring option for dynamical ABL variables
+   LOGICAL , PUBLIC            ::   ln_geos_winds  !: large-scale restoring of ABL winds toward geostrophic winds
+   LOGICAL , PUBLIC            ::   ln_hpgls_frc   !: forcing of ABL winds by large-scale pressure gradient 
+   LOGICAL , PUBLIC            ::   ln_smth_pblh   !: smoothing of atmospheric PBL height 
+
+   LOGICAL           , PUBLIC ::   ln_rstart_abl    !: (de)activate abl restart
+   CHARACTER(len=256), PUBLIC ::   cn_ablrst_in     !: suffix of abl restart name (input)
+   CHARACTER(len=256), PUBLIC ::   cn_ablrst_out    !: suffix of abl restart name (output)
+   CHARACTER(len=256), PUBLIC ::   cn_ablrst_indir  !: abl restart input directory
+   CHARACTER(len=256), PUBLIC ::   cn_ablrst_outdir !: abl restart output directory
+
+   !!---------------------------------------------------------------------
+   !! ABL parameters for TKE turbulent closure
+   !!---------------------------------------------------------------------
+   REAL(wp), PUBLIC, PARAMETER ::   tke_min   = 1.e-6_wp          !: minimum TKE
+   REAL(wp), PUBLIC, PARAMETER ::   avm_bak   = 1.e-4_wp          !: background viscosity
+   REAL(wp), PUBLIC, PARAMETER ::   avt_bak   = 1.e-5_wp          !: background diffusion
+   REAL(wp), PUBLIC, PARAMETER ::   itvref    = 1.0_wp / 288.0_wp !: inverse of reference virtual temperature     
+   !++ TKE closure parameters
+   REAL(wp), PUBLIC, PARAMETER ::   rn_phimax = (1._wp - 2.2_wp) / 2.2_wp !: maximum value for Ri * mxl^2 * N^2 / tke in phiz computation
+   REAL(wp), PUBLIC, PARAMETER ::   rn_Cek    = 258._wp                   !: Ekman constant for Richardson number 
+   REAL(wp), PUBLIC, PARAMETER ::   rn_epssfc = 1._wp / ( 1._wp + 2.8_wp * 2.8_wp )
+   REAL(wp), PUBLIC            ::   rn_ceps                       !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_cm                         !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_ct                         !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_ce                         !: namelist parameter 
+   REAL(wp), PUBLIC            ::   rn_Rod                        !: namelist parameter   
+   REAL(wp), PUBLIC            ::   rn_Sch    
+   REAL(wp), PUBLIC            ::   mxl_min    
+   REAL(wp), PUBLIC            ::   rn_ldyn_min                   !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_ldyn_max                   !: namelist parameter  
+   REAL(wp), PUBLIC            ::   rn_ltra_min                   !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_ltra_max                   !: namelist parameter
+   REAL(wp), PUBLIC            ::   rn_Ric                        !: critical Richardson number 
+
+   !!---------------------------------------------------------------------
+   !! ABL parameters for the vertical profile of the restoring term 
+   !!---------------------------------------------------------------------
+   REAL(wp), PUBLIC, PARAMETER ::   jp_bmin    =   0.5_wp 
+   REAL(wp), PUBLIC, PARAMETER ::   jp_bmax    =   1.5_wp
+   REAL(wp), PUBLIC            ::   jp_alp0_tra
+   REAL(wp), PUBLIC            ::   jp_alp1_tra   
+   REAL(wp), PUBLIC            ::   jp_alp2_tra   
+   REAL(wp), PUBLIC            ::   jp_alp3_tra   
+   REAL(wp), PUBLIC            ::   jp_alp0_dyn
+   REAL(wp), PUBLIC            ::   jp_alp1_dyn   
+   REAL(wp), PUBLIC            ::   jp_alp2_dyn   
+   REAL(wp), PUBLIC            ::   jp_alp3_dyn  
+   REAL(wp), PUBLIC            ::   jp_pblh_min
+   REAL(wp), PUBLIC            ::   jp_pblh_max      
+   ! parameter for the semi-implicit treatment of Coriolis term  
+   REAL(wp), PUBLIC, PARAMETER ::   gamma_Cor  = 0.55_wp
+   ! ABL timestep
+   REAL(wp), PUBLIC            :: rDt_abl
+
+   !!---------------------------------------------------------------------
+   !! ABL parameters for the diagnostic mixing length option nn_amxl = 1 
+   !!---------------------------------------------------------------------   
+   REAL(wp), PUBLIC, PARAMETER ::   amx1 =    4.3995604393911742_wp
+   REAL(wp), PUBLIC, PARAMETER ::   amx2 =  -18.159100102732943_wp
+   REAL(wp), PUBLIC, PARAMETER ::   amx3 =   40.241226956967239_wp
+   REAL(wp), PUBLIC, PARAMETER ::   amx4 =  -43.603409583363678_wp
+   REAL(wp), PUBLIC, PARAMETER ::   amx5 =   17.121715347554314_wp
+   REAL(wp), PUBLIC, PARAMETER ::   bmx1 =  -16.262675447730114_wp
+   REAL(wp), PUBLIC, PARAMETER ::   bmx2 =   85.088728134110781_wp
+   REAL(wp), PUBLIC, PARAMETER ::   bmx3 = -193.46548261141191_wp
+   REAL(wp), PUBLIC, PARAMETER ::   bmx4 =  196.71548261141191_wp
+   REAL(wp), PUBLIC, PARAMETER ::   bmx5 =  -72.076052686380677_wp 
+
+   !!----------------------------------------------------------------------
+   !! NEMO/ABL 4.0 , NEMO Consortium (2018)
+   !! $Id: sbc_oce.F90 10882 2019-04-17 15:40:17Z clem $
+   !! Software governed by the CeCILL license (see ./LICENSE)
+   !!======================================================================
+END MODULE par_abl
